
/* ************************************************************************ *
 *              Written by Alex de Kruijff                2009              *
 * ************************************************************************ *
 * This source was written with a tabstop every four characters             *
 * In vi type :set ts=4                                                     *
 * ************************************************************************ */

#include "configure.h"
#include "toolkit.h"
#include "filename.h"
#include "filegroup.h"
#include "sizegroup.h"
#include "holder.h"
#include "printhardlinked.h"

int PrintHardLinked::visit(Holder &holder) {return 0; }
int PrintHardLinked::visit(SizeGroup &sizegroup)
{
	fileSize = sizegroup.getFileSize();
}

int PrintHardLinked::visit(FileGroup &filegroup)
{
	size_t n = filegroup.getBoundry();
#ifndef LIST
	for (size_t i = 0;  i < n; ++i) if (filegroup[i] != NULL)
		for (size_t j = i + 1; j < n; ++j) if (filegroup[j] != NULL)
			outputHardLinked(filegroup[i]->data(), filegroup[j]->data(),
				filegroup.st_nlink, fileSize, sep);
#else // LIST
	Iterator<Filename> &a = *filegroup.createIterator();
	Iterator<Filename> &b = *filegroup.createIterator();
	for(; !a.end(); ++a) if (a.getItem() != NULL)
	{
		b = a;
		++b;
		for(; !b.end(); ++b) if (b.getItem() != NULL)
			outputHardLinked(a.getItem()->data(), b.getItem()->data(),
				filegroup.st_nlink, fileSize, sep);
	}
	delete &a;
	delete &b;
#endif // LIST
	return 1;
}

void PrintHardLinked::visit(Filename &filename) {}

